<script>
import * as d3 from 'd3';
// in full builds helpers are exposed as Vuex.mapState
import { mapState } from 'vuex'
import { useStore } from "vuex";

export default {
  // Properties returned from data() become reactive state
  // and will be exposed on `this`.
  data() {
    return {
      count: 0,
      forces_history: [],
      selected: 'drex1',
      input_text: '1696106607fb16d6',
      image_url: '',
      image_url_search_routine: '',
      image_url_eef: '',
      image_url_eef_2d_path: '',
      image_url_pallet: '',
      request_url: '',
      get_data_url: '',
      totalVuePackages: 0,
      weight: '',
      done: '',
      hostname: '0.0.0.0',
    }
  },
  computed: {
    count_global() {
      return this.$store.state.count
    },
    trace_global() {
      this.input_text = this.$store.state.trace.trace
      this.selected = this.$store.state.trace.loader
      this.download()
      return this.$store.state.trace
    }
  },

  // Methods are functions that mutate state and trigger updates.
  // They can be bound as event listeners in templates.
  methods: {
    get_count() {
      self.$store.state.count
    },
    update_figures() {
      this.image_url = 'http://' + this.hostname + ':8811' + '/get-image/' + this.selected + '/' + this.input_text + '.png'
      this.image_url_search_routine = 'http://' + this.hostname + ':8811' + '/get-image/' + this.selected + '/' + this.input_text + '_search_routine.png'
      this.image_url_eef = 'http://' + this.hostname + ':8811' + '/get-image/' + this.selected + '/' + this.input_text + '_eef.png'
      this.image_url_eef_2d_path = 'http://' + this.hostname + ':8811' + '/get-image/' + this.selected + '/' + this.input_text + '_eef_2D_path.png'
      this.image_url_pallet = 'http://' + this.hostname + ':8811' + '/get-image/' + this.selected + '/' + this.input_text + '_pallet.png'
    },
    download() {
      this.request_url = 'http://' + this.hostname + ':8811' + '/download-log/' + this.selected + '/' + this.input_text
      // this.forces_history.push(this.imageUrl)
      console.log(this.$store.state.count)
      fetch(this.request_url)
        .then(response => response.json())
        .then(data => {
          this.update_figures();
        })
        .catch(error => {
          console.error(error);
        });

      this.request_url = 'http://' + this.hostname + ':8811' + '/get-data/' + this.selected + '/' + this.input_text
      fetch(this.request_url)
        .then(response => response.json())
        .then(data => {
          this.done = data['done']
          this.weight = parseFloat(data['weight'])
          if (!isNaN(this.weight)) {
            this.weight = this.weight.toFixed(2);
          }
        })
        .catch(error => {
          // Handle any errors
          console.error(error);
        });
    },
  },

  // Lifecycle hooks are called at different stages
  // of a component's lifecycle.
  // This function will be called when the component is mounted.
  mounted() {
    this.hostname = window.location.hostname;
    console.log(`Hostname is ${this.hostname}`)
    console.log(`The initial count is ${this.count}.`)
    console.log(`The initial forces_history is ${this.forces_history}`)
  },
}
</script>



<template>
  <div class="container">
    <h2> Tight Packing mini-Visualizer </h2>
    <br />
    <h4> Log trace </h4>
    <br />
    <div class="row">
      <div class="col-md-6">
        <input type="text" class="form-control" v-model="input_text" />
      </div>

      <div class="col-md">
        <select class="form-select" v-model="selected">
          <option disabled value="">Please select one</option>
          <option>drex1</option>
          <option>drex2</option>
          <option>drex6</option>
          <option>drex7</option>
          <option>drex8</option>
        </select>
      </div>

      <div class="col-md">
        <button class="btn btn-primary" @click="download"> Add item </button>
      </div>

    </div>
    <br />
    <p hidden>trace_global: {{ trace_global }}</p>

    <!-- Meta data -->
    <div class="meta">
      <table class="table">
        <thead>
          <tr>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td> Weight (kg) </td>
            <td> {{ weight }}</td>
          </tr>

          <tr>
            <td> Success </td>
            <td> {{ done }}</td>
          </tr>
        </tbody>
      </table>
    </div>

    <br />

    <h4> Visualization </h4>

    <div class="row">
      <div class="col-md-12">
        <h6> Pallet </h6>
        <img :src="image_url_pallet" alt="Image from API" class="img-fluid" style="width: 40%;">
        <br />
        <h6> Forces </h6>
        <img :src="image_url" alt="Image from API" class="img-fluid">
        <h6> Search Routine Step </h6>
        <img :src="image_url_search_routine" alt="Image from API" class="img-fluid">
        <h6> End effector position </h6>
        <img :src="image_url_eef" alt="Image from API" class="img-fluid">
        <h6> End effector position 2D Path </h6>
        <img :src="image_url_eef_2d_path" alt="Image from API" class="img-fluid">
      </div>
    </div>
  </div>
</template>


<style>
.container {
  margin-top: 30pt;
}

.analytics {
  align-items: center;
}

.input {
  height: 30px;
}

.img {
  width: 100%;
}

.meta {
  width: 90%;
}
</style>